unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, Buttons, Delaunay, ToolWin, ComCtrls, StdCtrls, Menus;

type

  TMouseAction = (maUp, maLDown, maRDown, maLMove, maRMove, maLSelect);

  TForm1 = class(TForm)
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    SBox: TScrollBox;
    Images: TImageList;
    D: TDelaunay;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    ToolButton8: TToolButton;
    CHVoron: TToolButton;
    CHTrian: TToolButton;
    AktV: TToolButton;
    SBar: TStatusBar;
    MainMenu1: TMainMenu;
    Soubor1: TMenuItem;
    Zobrazen1: TMenuItem;
    Demo1: TMenuItem;
    Pkazy1: TMenuItem;
    Konec1: TMenuItem;
    Zvtit1: TMenuItem;
    Zmenit1: TMenuItem;
    DelTri: TMenuItem;
    VorDiag: TMenuItem;
    AktObl: TMenuItem;
    Separ1: TMenuItem;
    Edit1: TMenuItem;
    Vloitnovbod1: TMenuItem;
    Smazatoznaenbody1: TMenuItem;
    N1: TMenuItem;
    Oznaitve1: TMenuItem;
    Odznaitve1: TMenuItem;
    CHCircle: TToolButton;
    Spustitdemo1: TMenuItem;
    Timer: TTimer;
    Panel: TPanel;
    PB: TPaintBox;
    Vloits1: TMenuItem;
    Vloitkrunici1: TMenuItem;
    Smazatduplicitn1: TMenuItem;
    Vloitsinusovku1: TMenuItem;
    Smazatve1: TMenuItem;
    Vloitnhodn1: TMenuItem;
    procedure PBMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PBPaint(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure DEnumVoronoi(Sender: TObject; Edge: TDEdge);
    procedure DEnumPoints(Sender: TObject; Point: TDPoint);
    procedure DEnumEdges(Sender: TObject; Edge: TDEdge);
    procedure FormCreate(Sender: TObject);
    procedure SBoxResize(Sender: TObject);
    procedure ToolButton4Click(Sender: TObject);
    procedure ToolButton2Click(Sender: TObject);
    procedure PBMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure PBMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure DInsert(Sender: TObject; Point: TDPoint);
    procedure AppIdle(Sender: TObject; var Done: Boolean);
    procedure FormDestroy(Sender: TObject);
    procedure ToolButton6Click(Sender: TObject);
    procedure ToolButton1Click(Sender: TObject);
    procedure CHTrianClick(Sender: TObject);
    procedure Konec1Click(Sender: TObject);
    procedure Oznaitve1Click(Sender: TObject);
    procedure Spustitdemo1Click(Sender: TObject);
    procedure TimerTimer(Sender: TObject);
    procedure Smazatduplicitn1Click(Sender: TObject);
    procedure Vloitkrunici1Click(Sender: TObject);
    procedure Vloits1Click(Sender: TObject);
    procedure Vloitsinusovku1Click(Sender: TObject);
    procedure Smazatve1Click(Sender: TObject);
    procedure DelTriClick(Sender: TObject);
    procedure VorDiagClick(Sender: TObject);
    procedure AktOblClick(Sender: TObject);
    procedure Vloitnhodn1Click(Sender: TObject);
  private
    { Private declarations }
    FZoom: Single;
    FZoomIndex: ShortInt;
    procedure SetZoom(New: ShortInt);
    procedure Draw;
    function WinX(X: Double): Integer;
    function WinY(Y: Double): Integer;
    function Del(X: Integer): Integer;
    procedure DEnumPEdges(Sender: TObject; Edge: TDEdge);
    procedure MovePoints;
    function Clip(var X1, Y1, X2, Y2: Double): Boolean;
  public
    { Public declarations }
    Back: TBitmap;
    Node, NodeY, NodeCH: array[2..4] of TBitmap;
    AktT: TDTriangle;
    AktP, OnP: TDPoint;
    XDown, YDown, XMove, YMove: Integer;
    Action: TMouseAction;
    Changed: Boolean;
    SWidth: Integer;
    property Zoom: Single read FZoom;
    property ZoomIndex: ShortInt read FZoomIndex write SetZoom;
  end;

  TPoint = class(TDPoint)
    Selected: Boolean;
    dX, dY: ShortInt;
    constructor Create(X, Y: Integer);
  end;

var
  Form1: TForm1;

const
  crOn1Node = 1;
  crOn2Node = 2;
  crOnXNode = 3;
  crNodeMove = 4;
  crSelect = 5;
  crZoomUp = 6;
  crZoomDown = 7;
  ZoomSize: array[0..4] of Byte = (1, 3, 6, 10, 20);

implementation

uses NewPoint;

{$R *.DFM}

constructor TPoint.Create(X, Y: Integer);
begin
  inherited;
  dX := Random(5) - 2;
  dY := Random(5) - 2;
end;

procedure TForm1.FormCreate(Sender: TObject);
const
  S = 'NODE%s%d';
var
  i: Integer;  
begin
  Randomize;
  Back := TBitmap.Create;
  for i := 2 to 4 do
  begin
    Node[i] := TBitmap.Create;
    Node[i].Transparent := true;
    Node[i].LoadFromResourceName(HInstance, Format(S, ['', 5 - i]));
    NodeY[i] := TBitmap.Create;
    NodeY[i].Transparent := true;
    NodeY[i].LoadFromResourceName(HInstance, Format(S, ['Y', 5 - i]));
    NodeCH[i] := TBitmap.Create;
    NodeCH[i].Transparent := true;
    NodeCH[i].LoadFromResourceName(HInstance, Format(S, ['CH', 5 - i]));
  end;

  Screen.Cursors[crOn1Node] := LoadCursor(HInstance, 'ON1NODE');
  Screen.Cursors[crOn2Node] := LoadCursor(HInstance, 'ON2NODE');
  Screen.Cursors[crOnXNode] := LoadCursor(HInstance, 'ON3NODE');
  Screen.Cursors[crNodeMove] := LoadCursor(HInstance, 'NODEMOVE');
  Screen.Cursors[crSelect] := LoadCursor(HInstance, 'SELECT');
  Screen.Cursors[crZoomUp] := LoadCursor(HInstance, 'ZOOMUP');
  Screen.Cursors[crZoomDown] := LoadCursor(HInstance, 'ZOOMDOWN');
  Application.OnIdle := AppIdle;
  Action := maUp;

  SBoxResize(nil);
  ZoomIndex := 2;
end;

procedure TForm1.AppIdle(Sender: TObject; var Done: Boolean);
begin
  if not Changed then exit;
  PBPaint(Self);
  SBar.Panels[1].Text := Format('Bod: %d', [D.Count]);
  Changed := false;
end;

procedure TForm1.PBPaint(Sender: TObject);
begin
  Draw;
  PB.Canvas.Draw(-Panel.Left, -Panel.Top, Back);
end;

procedure TForm1.Draw;
begin
  with Back.Canvas do
  begin
    Brush.Color := clWhite;
    Pen.Color := clBlack;
    Rectangle(Panel.Left, Panel.Top, Panel.Width, Panel.Height);
    if CHTrian.Down then
    begin
      // Vykreslit hrany
      D.OnEnumEdge := DEnumEdges;
      Pen.Color := clGray;
      Pen.Style := psDot;
      D.EnumEdges(false);
      Pen.Style := psSolid;
    end;
    SWidth := Screen.Width;
    if CHVoron.Down then
    begin
      // Vykreslit Voroneho
      D.OnEnumEdge := DEnumVoronoi;
      Pen.Color := clBlue;
      Pen.Style := psSolid;
      D.EnumEdges(false);
    end;
    // Vykreslit aktualni region
    if AktV.Down and (AktP <> nil) then
    begin
      Pen.Style := psDot;
      Pen.Color := clNavy;
      Brush.Color := clNavy;
      AktP.EnumEdges(DEnumVoronoi);
      Pen.Style := psSolid;
    end;
    // Vykreslit body
    Pen.Color := clBlack;
    Brush.Color := clRed;
    D.OnEnumPoint := DEnumPoints;
    D.EnumPoints(true);
    // Vykreslit sousedy a aktualni bod
    if OnP <> nil then
    begin
      if (ZoomIndex > 1) and CHCircle.Down then
      begin
        OnP.EnumEdges(DEnumPEdges);
        Draw(WinX(OnP.X - 0.5), WinY(OnP.Y - 0.5), NodeY[ZoomIndex]);
      end else begin
        Pen.Color := clBlack;
        Brush.Color := clYellow;
        DEnumPoints(nil, OnP);
      end;
    end;
  end;
end;

procedure TForm1.DEnumPEdges(Sender: TObject; Edge: TDEdge);
var P: TDPoint;
begin
  if Edge.LeftP = OnP.Original then P := Edge.RightP else P := Edge.LeftP;
  Back.Canvas.Draw(WinX(P.X - 0.5), WinY(P.Y - 0.5), NodeCH[ZoomIndex])
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
var
  i, x, y: Integer;
begin
  Randomize;
  for i := 1 to 1000 do
    begin
      x := Random(900); y := Random(900);
      D.Insert(x + 5, y + 5);
    end;
  Changed := true;
end;

procedure ClipOn(var A, B, C, D: Double; Max: Integer);
begin
  C := D + (C - D) * (B - Max)/(B - A);
  A := Max;
end;

function TForm1.Clip(var X1, Y1, X2, Y2: Double): Boolean;
begin
  X1 := WinX(X1);
  Y1 := WinY(Y1);
  X2 := WinX(X2);
  Y2 := WinY(Y2);
  Result := false;
  // Orez X
  if X1 < 0 then
    if X2 < 0 then exit else ClipOn(X1, X2, Y1, Y2, 0)
  else
    if X1 > SBox.Width then
      if X2 > SBox.Width then exit else ClipOn(X1, X2, Y1, Y2, SBox.Width);
  if X2 < 0 then
    ClipOn(X2, X1, Y2, Y1, 0)
  else
    if X2 > SBox.Width then ClipOn(X2, X1, Y2, Y1, SBox.Width);

  // Orez Y
  if Y1 < 0 then
    if Y2 < 0 then exit else ClipOn(Y1, Y2, X1, X2, 0)
  else
    if Y1 > SBox.Height then
      if Y2 > SBox.Height then exit else ClipOn(Y1, Y2, X1, X2, SBox.Height);
  if Y2 < 0 then
    ClipOn(Y2, Y1, X2, X1, 0)
  else
    if Y2 > SBox.Height then ClipOn(Y2, Y1, X2, X1, SBox.Height);
  Result := true;
end;

procedure TForm1.DEnumVoronoi(Sender: TObject; Edge: TDEdge);
var
  X1, Y1, X2, Y2: Double;
begin
  Edge.GetVoronoi(X1, Y1, X2, Y2);
  if Edge.InvE = nil then
  begin
    X1 := X2 + (X1 - X2) * 10000;
    Y1 := Y2 + (Y1 - Y2) * 10000;
    if Edge.T = nil then
    begin
      X2 := X1 + (X2 - X1) * 2 ;
      Y2 := Y1 + (Y2 - Y1) * 2 ;
    end;
  end;

  if Clip(X1, Y1, X2, Y2) then
    with Back.Canvas do
    begin
      MoveTo(Round(X1), Round(Y1));
      LineTo(Round(X2), Round(Y2));
    end;
end;

procedure TForm1.DEnumPoints(Sender: TObject; Point: TDPoint);
begin
  with Point, Back.Canvas do
  begin
    if (ZoomIndex > 1) and CHCircle.Down then
      Draw(WinX(X - 0.5), WinY(Y - 0.5), Node[ZoomIndex])
    else
      Rectangle(WinX(X - 0.5), WinY(Y - 0.5), WinX(X + 0.5), WinY(Y + 0.5));
    if TPoint(Point).Selected then
      Rectangle(WinX(X + 0.5), WinY(Y + 0.5), WinX(X + 0.5) + 2, WinY(Y + 0.5) + 2);
  end;
end;

procedure TForm1.DEnumEdges(Sender: TObject; Edge: TDEdge);
var X1, X2, Y1, Y2: Double;
begin
  with Edge, Back.Canvas do
  begin
    if Edge.InvE = nil then
      Back.Canvas.Pen.Style := psSolid
    else
      Back.Canvas.Pen.Style := psDot;
    X1 := LeftP.X; X2 := RightP.X;
    Y1 := LeftP.Y; Y2 := RightP.Y;
    if Clip(X1, Y1, X2, Y2) then
    begin
      MoveTo(Round(X1), Round(Y1));
      LineTo(Round(X2), Round(Y2));
    end;
  end;
end;

procedure TForm1.SetZoom(New: ShortInt);
begin
  if New > High(ZoomSize) then New := High(ZoomSize);
  if New < Low(ZoomSize) then New := Low(ZoomSize);
  if New = ZoomIndex then exit;
  FZoomIndex := New;
  FZoom := 1 / ZoomSize[ZoomIndex];
  Panel.Width := Round(100 / Zoom);
  Panel.Height := Round(100 / Zoom);
end;

procedure TForm1.SBoxResize(Sender: TObject);
begin
  Back.Width := SBox.ClientWidth;
  Back.Height := SBox.ClientHeight;
end;

function TForm1.WinX(X: Double): Integer;
begin
  Result := Round(X / Zoom) + Panel.Left;
end;

function TForm1.WinY(Y: Double): Integer;
begin
  Result := Round(Y / Zoom) + Panel.Top;
end;

function TForm1.Del(X: Integer): Integer;
begin
  Result := Round((X * Zoom));
end;

procedure TForm1.ToolButton4Click(Sender: TObject);
begin
  ZoomIndex := ZoomIndex + 1;
end;

procedure TForm1.ToolButton2Click(Sender: TObject);
begin
  ZoomIndex := ZoomIndex - 1;
end;

procedure Change(var X, Y: Integer);
var a: Integer;
begin
  a := X; X := Y; Y := a;
end;

procedure TForm1.PBMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  i, C: Integer;
  P: TPoint;
begin
  if Action = maLDown then D.InsertPoint(TPoint.Create(Del(X), Del(Y)));
  if Action = maLSelect then
  begin
    XDown := Del(XDown); YDown := Del(YDown);
    XMove := Del(XMove); YMove:= Del(YMove);
    if XDown > XMove then Change(XDown, XMove);
    if YDown > YMove then Change(YDown, YMove);
    C := 0;
    for i := 0 to D.Count - 1 do
    begin
      P := TPoint(D[i]);
      if (P.X >= XDown) and (P.Y >= YDown) and (P.Y <= YMove) and (P.X <= XMove) then
      begin
        P.Selected := true;
        inc(C);
      end else
        P.Selected := false;
    end;
    Changed := true;
    SBar.Panels[2].Text := Format('Ozna: %d', [C]);
  end;
  Action := maUp;
  Screen.Cursor := crDefault;
  PBMouseMove(Self, Shift, X, Y);
end;

procedure TForm1.PBMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if Button = mbLeft then
  begin
    Action := maLDown;
    XDown := X;
    YDown := Y;
  end else begin
    if OnP = nil then exit;
    if OnP.Index < D.Count - 1 then
    begin
      if not D[OnP.Index + 1].IsOriginal then OnP := D[OnP.Index + 1];
    end;
    OnP.Destroy;
    OnP := nil;
    Changed := true;
    PBMouseMove(Self, Shift, X, Y);
  end;
end;

procedure TForm1.PBMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var
  P: TDPoint;
begin
  SBar.Panels[0].Text := Format('%d:%d', [Del(X), Del(Y)]);
  case Action of
    maUp:
      begin
        P := D.Nearest(Del(X), Del(Y));
        if P <> AktP then
          Changed := true;
        AktP := P;
        P := D.ByCoord(Del(X), Del(Y));
        if P <> OnP then Changed := true;
        OnP := P;
        if OnP <> nil then
        begin
          case OnP.Count of
            1: PB.Cursor := crOn1Node;
            2: PB.Cursor := crOn2Node;
            else PB.Cursor := crOnXNode;
          end;
        end else begin
          PB.Cursor := crArrow;
        end;
      end;
    maLDown:
      if sqrt(sqr(X - XDown) + sqr(Y - YDown)) > 5 then
      begin
        if OnP = nil then
        begin
          Action := maLSelect;
          Screen.Cursor := crSelect;
          XMove := XDown; YMove := YDown;
        end else begin
          Action := maLMove;
          Screen.Cursor := crNodeMove;
        end;
      end;
  end;

  if (Action = maLMove) then
  begin // Move Points
    XMove := Del(X) - OnP.X;
    YMove := Del(Y) - OnP.Y;
    if ((XMove <> 0) or (YMove <> 0)) and TPoint(OnP).Selected then
      MovePoints
    else
      OnP.Move(Del(X), Del(Y));
  end;

  if (Action = maLSelect) and ((X <> XMove) or (Y <> YMove)) then
    with PB.Canvas do
    begin
      Pen.Color := clWhite;
      Pen.Mode := pmXor;
      Pen.Style := psDot;
      Brush.Style := bsClear;
      Rectangle(XDown, YDown, XMove, YMove);
      Rectangle(XDown, YDown, X, Y);
    end;

  if OnP <> nil then
    with SBar.Panels[3] do
    begin
      Text := Format('Poet: %d', [OnP.Count]);
      if TPoint(OnP).Selected then Text := Text + ', oznaen';
    end
  else
    SBar.Panels[3].Text := '';
  XMove := X; YMove := Y;
end;

procedure TForm1.MovePoints;
var
  L: TList;
  i: Integer;
  P: TPoint;
begin
  L := TList.Create;
  try
    D.GetPList(L);
    for i := 0 to L.Count - 1 do
    begin
      P := L.List[i];
      if P.Selected then P.Move(P.X + XMove, P.Y + YMove);
    end;
  finally
    L.Destroy;
  end;
end;

procedure TForm1.DInsert(Sender: TObject; Point: TDPoint);
begin
  Changed := true;
end;

procedure TForm1.FormDestroy(Sender: TObject);
var i: Byte;
begin
  for i := 2 to 4 do
  begin
    Node[i].Destroy;
    NodeCH[i].Destroy;
    NodeY[i].Destroy;
  end;
end;

// Delete selected points
procedure TForm1.ToolButton6Click(Sender: TObject);
var
  L: TList;
  P: TPoint;
  i: Integer;
begin
  L := TList.Create;
  try
    D.GetPList(L);
    for i := 0 to L.Count - 1 do
    begin
      P := L.List[i];
      if P.Selected then P.Destroy;
    end;
  finally
    L.Destroy;
  end;
  OnP := nil;
  AktP := nil;
  SBar.Panels[2].Text := 'Ozna: 0';
end;

procedure TForm1.ToolButton1Click(Sender: TObject);
begin
  if Form2.ShowModal = mrOK then
  begin
    try
      D.InsertPoint(TPoint.Create(
        StrToInt(Form2.EditX.Text), StrToInt(Form2.EditY.Text)));
    except
    end;
  end;
end;

procedure TForm1.CHTrianClick(Sender: TObject);
begin
  Changed := true;
end;

procedure TForm1.Konec1Click(Sender: TObject);
begin
  Close;
end;

procedure TForm1.Oznaitve1Click(Sender: TObject);
var
  i: Integer;
  B: Boolean;
begin
  B := Sender = Oznaitve1;
  for i := 0 to D.Count - 1 do TPoint(D[i]).Selected := B;
  Changed := true;
end;

procedure TForm1.Spustitdemo1Click(Sender: TObject);
begin
  Spustitdemo1.Checked := not Spustitdemo1.Checked;
  Timer.Enabled := Spustitdemo1.Checked;
end;

procedure TForm1.TimerTimer(Sender: TObject);
var
  L: TList;
  i: Integer;
begin
  if (Action <> maUp) then exit;
  L := TList.Create;
  D.GetPList(L);
  D.Clear(False);
  try
    for i := 0 to L.Count - 1 do
      with TPoint(L[i]) do
      begin
        Move(X + dX, Y + dY);
        if (X < 0) or (X > 100) then dX := -dX;
        if (Y < 0) or (Y > 100) then dY := -dY;
        Owner := D;
      end;
  finally
    L.Destroy;
  end;
  PBPaint(nil);
end;

procedure TForm1.Smazatduplicitn1Click(Sender: TObject);
begin
 D.DeleteDupl;
 Changed := True;
end;

procedure TForm1.Vloitkrunici1Click(Sender: TObject);
var
  Alf: Double;
begin
  Alf := 0;
  while Alf < 2 * PI do
  begin
    D.InsertPoint(TPoint.Create(
      Round(50 + cos(Alf) * 30), Round(50 + sin(Alf) * 30)));
    Alf := Alf + PI / 18;
  end;
  Changed := True;
end;

procedure TForm1.Vloits1Click(Sender: TObject);
var
  i, ii: Integer;
begin
  i := 5;
  while i < 95 do
  begin
    ii := 5;
    while ii < 95 do
    begin
      D.InsertPoint(TPoint.Create(i, ii));
      inc(ii, 5);
    end;
    inc(i, 5);
  end;
  Changed := True;
end;

procedure TForm1.Vloitsinusovku1Click(Sender: TObject);
var
  Alf: Double;
begin
  Alf := 0;
  while Alf < 2 * PI do
  begin
    D.InsertPoint(TPoint.Create(
      Round(5 + Alf / PI * 45), Round(50 + sin(Alf) * 30)));
    Alf := Alf + PI / 18;
  end;
  Changed := True;
end;

procedure TForm1.Smazatve1Click(Sender: TObject);
begin
  D.Clear(True);
  OnP := nil; AktP := nil;
  Changed := true;
end;

procedure TForm1.DelTriClick(Sender: TObject);
begin
  CHTrian.Down := not CHTrian.Down;
  DelTri.Checked := CHTrian.Down;
  Changed := True;
end;

procedure TForm1.VorDiagClick(Sender: TObject);
begin
  CHVoron.Down := not CHVoron.Down;
  VorDiag.Checked := CHVoron.Down;
  Changed := True;
end;

procedure TForm1.AktOblClick(Sender: TObject);
begin
  AktV.Down := not AktV.Down;
  AktObl.Checked := AktV.Down;
  Changed := True;
end;

procedure TForm1.Vloitnhodn1Click(Sender: TObject);
var
  S: String;
  i: Integer;
begin
  S := '100';
  if InputQuery('Demo', 'Poet bod:', S) then
  begin
    try
      for i := 1 to StrToInt(S) do
        D.InsertPoint(TPoint.Create(Random(100), Random(100))); 
    except
    end;
  end;
end;

end.
